/* 
 * File:   spurious.c
 * Author: Carlo Alessandro Nicolau @ INFN
 * 
 * Firmware for BPD board.
 * Functions that could (and thus should) be auto-generated but would require a big refactoring of python code.
 * 
 */

#include "spurious.h"
#include "errors.h"
#include "generated/sources/variables.h"
#include "mcc_generated_files/mcc.h"

// analog and digital alarm structures are defined and initialized in file variables.c under generated folder

//bool variable_is_analog_by_enum(enum_variable_number_t _variable_index) {
//    switch(_variable_index) {        
//        
//        case VARIABLE_NUMBER_MON_DUL_BOARDTEMP:
//        case VARIABLE_NUMBER_MON_TEMP2:
//        case VARIABLE_NUMBER_MON_TEMP1:
//        case VARIABLE_NUMBER_MON_VEOC_RTN_I:
//        case VARIABLE_NUMBER_MON_VEOC_FWR_I:
//        case VARIABLE_NUMBER_MON_HYDRO_I:
//        case VARIABLE_NUMBER_MON_INPUT_V:
//        case VARIABLE_NUMBER_MON_LBL_I:
//        case VARIABLE_NUMBER_MON_GLRA_I:
//        case VARIABLE_NUMBER_MON_GLRB_I:
//        case VARIABLE_NUMBER_MON_PWB_I:
//            return true;
//            
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS1:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS2:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG1:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG2:
//        case VARIABLE_NUMBER_FLAG_HYDRO_PWR_FAULT:
//        case VARIABLE_NUMBER_FLAG_LBL_PWR_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRA_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRB_FAULT:
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRA_GOOD:
//        case VARIABLE_NUMBER_FLAG_GLRB_GOOD:
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_GOOD:
//            return false;
//            
//    }   
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return false;
//}
//
//analog_variable_t* analog_variable_get_pointer_by_enum(enum_variable_number_t _variable_index) {
//    switch(_variable_index) {
//        
//        case VARIABLE_NUMBER_MON_DUL_BOARDTEMP: return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_DUL_BOARDTEMP]);
//        case VARIABLE_NUMBER_MON_TEMP2:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP2]);
//        case VARIABLE_NUMBER_MON_TEMP1:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP1]);
//        case VARIABLE_NUMBER_MON_VEOC_RTN_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_RTN_I]);
//        case VARIABLE_NUMBER_MON_VEOC_FWR_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_FWR_I]);
//        case VARIABLE_NUMBER_MON_HYDRO_I:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_HYDRO_I]);
//        case VARIABLE_NUMBER_MON_INPUT_V:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_INPUT_V]);
//        case VARIABLE_NUMBER_MON_LBL_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_LBL_I]);
//        case VARIABLE_NUMBER_MON_GLRA_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRA_I]);
//        case VARIABLE_NUMBER_MON_GLRB_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRB_I]);
//        case VARIABLE_NUMBER_MON_PWB_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_PWB_I]);
//        
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS1:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS2:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG1:
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG2:
//        case VARIABLE_NUMBER_FLAG_HYDRO_PWR_FAULT:
//        case VARIABLE_NUMBER_FLAG_LBL_PWR_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRA_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRB_FAULT:
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_FAULT:
//        case VARIABLE_NUMBER_FLAG_GLRA_GOOD:
//        case VARIABLE_NUMBER_FLAG_GLRB_GOOD:
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_GOOD:
//            error_die_forever();
//            break;   
//            
//    }
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return &(analog_variables[0]); 
//}
//
//digital_variable_t* digital_variable_get_pointer_by_enum(enum_variable_number_t _variable_index) {
//    switch(_variable_index) {       
//        
//        case VARIABLE_NUMBER_MON_DUL_BOARDTEMP:
//        case VARIABLE_NUMBER_MON_TEMP2:
//        case VARIABLE_NUMBER_MON_TEMP1:
//        case VARIABLE_NUMBER_MON_VEOC_RTN_I:
//        case VARIABLE_NUMBER_MON_VEOC_FWR_I:
//        case VARIABLE_NUMBER_MON_HYDRO_I:
//        case VARIABLE_NUMBER_MON_INPUT_V:
//        case VARIABLE_NUMBER_MON_LBL_I:
//        case VARIABLE_NUMBER_MON_GLRA_I:
//        case VARIABLE_NUMBER_MON_GLRB_I:
//        case VARIABLE_NUMBER_MON_PWB_I:   
//            error_die_forever();
//            break;       
//            
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS1:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMPOS1]);
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMPOS2:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMPOS2]);
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG1:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMNEG1]);
//        case VARIABLE_NUMBER_FLAG_DUL_ALARMNEG2:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMNEG2]);
//        case VARIABLE_NUMBER_FLAG_HYDRO_PWR_FAULT:  return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_HYDRO_PWR_FAULT]);
//        case VARIABLE_NUMBER_FLAG_LBL_PWR_FAULT:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_LBL_PWR_FAULT]);
//        case VARIABLE_NUMBER_FLAG_GLRA_FAULT:       return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRA_FAULT]);
//        case VARIABLE_NUMBER_FLAG_GLRB_FAULT:       return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRB_FAULT]);
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_FAULT: return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_POWERBOARD_FAULT]);
//        case VARIABLE_NUMBER_FLAG_GLRA_GOOD:        return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRA_GOOD]);
//        case VARIABLE_NUMBER_FLAG_GLRB_GOOD:        return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRB_GOOD]);
//        case VARIABLE_NUMBER_FLAG_POWERBOARD_GOOD:  return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_POWERBOARD_GOOD]);
//            
//    }
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return &(digital_variables[0]);    
//}
//
//bool alarm_is_analog_by_enum(enum_alarm_number_t _alarm_index) {    
//    switch(_alarm_index) {          
//        
//        case ALARM_NUMBER_ALARM_SLOW_MON_DUL_BOARDTEMP:
//        case ALARM_NUMBER_ALARM_FAST_MON_DUL_BOARDTEMP:
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP2:
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP2:
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP1:
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP1:
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_RTN_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_RTN_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_FWR_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_FWR_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_HYDRO_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_HYDRO_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_INPUT_V:
//        case ALARM_NUMBER_ALARM_FAST_MON_INPUT_V:
//        case ALARM_NUMBER_ALARM_SLOW_MON_LBL_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_LBL_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRA_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRA_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRB_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRB_I:
//        case ALARM_NUMBER_ALARM_SLOW_MON_PWB_I:
//        case ALARM_NUMBER_ALARM_FAST_MON_PWB_I:
//            return true;
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS1:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS2:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG1:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG2:
//        case ALARM_NUMBER_ALARM_FLAG_HYDRO_PWR_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_LBL_PWR_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_GOOD:
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_GOOD:
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_GOOD:
//            return false;
//            
//    }        
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return false;
//}
//
//analogalarm_info_t* alarm_get_analog_alarm_ptr_by_enum(enum_alarm_number_t _alarm_index) {   
//    switch(_alarm_index) {          
//        
//        case ALARM_NUMBER_ALARM_SLOW_MON_DUL_BOARDTEMP: return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_DUL_BOARDTEMP].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_DUL_BOARDTEMP: return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_DUL_BOARDTEMP].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP2:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP2].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP2:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP2].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP1:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP1].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP1:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_TEMP1].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_RTN_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_RTN_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_RTN_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_RTN_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_FWR_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_FWR_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_FWR_I:    return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_VEOC_FWR_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_HYDRO_I:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_HYDRO_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_HYDRO_I:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_HYDRO_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_INPUT_V:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_INPUT_V].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_INPUT_V:       return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_INPUT_V].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_LBL_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_LBL_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_LBL_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_LBL_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRA_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRA_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRA_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRA_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRB_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRB_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRB_I:        return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_GLRB_I].alarms.fast);
//        case ALARM_NUMBER_ALARM_SLOW_MON_PWB_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_PWB_I].alarms.slow);
//        case ALARM_NUMBER_ALARM_FAST_MON_PWB_I:         return &(analog_variables[ANALOG_VARIABLE_INDEX_MON_PWB_I].alarms.fast);
//        
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS1:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS2:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG1:
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG2:
//        case ALARM_NUMBER_ALARM_FLAG_HYDRO_PWR_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_LBL_PWR_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_FAULT:
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_GOOD:
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_GOOD:
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_GOOD:
//            error_die_forever();
//            break; 
//            
//    }
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return &(analog_variables[0].alarms.slow);
//}
//
//digitalalarm_info_t* alarm_get_digital_alarm_ptr_by_enum(enum_alarm_number_t _alarm_index) {
//    switch(_alarm_index) {  
//        
//        case ALARM_NUMBER_ALARM_SLOW_MON_DUL_BOARDTEMP:
//        case ALARM_NUMBER_ALARM_FAST_MON_DUL_BOARDTEMP:
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP2:        
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP2:        
//        case ALARM_NUMBER_ALARM_SLOW_MON_TEMP1:        
//        case ALARM_NUMBER_ALARM_FAST_MON_TEMP1:        
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_RTN_I:   
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_RTN_I:   
//        case ALARM_NUMBER_ALARM_SLOW_MON_VEOC_FWR_I:   
//        case ALARM_NUMBER_ALARM_FAST_MON_VEOC_FWR_I:   
//        case ALARM_NUMBER_ALARM_SLOW_MON_HYDRO_I:      
//        case ALARM_NUMBER_ALARM_FAST_MON_HYDRO_I:      
//        case ALARM_NUMBER_ALARM_SLOW_MON_INPUT_V:      
//        case ALARM_NUMBER_ALARM_FAST_MON_INPUT_V:      
//        case ALARM_NUMBER_ALARM_SLOW_MON_LBL_I:        
//        case ALARM_NUMBER_ALARM_FAST_MON_LBL_I:        
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRA_I:       
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRA_I:       
//        case ALARM_NUMBER_ALARM_SLOW_MON_GLRB_I:       
//        case ALARM_NUMBER_ALARM_FAST_MON_GLRB_I:       
//        case ALARM_NUMBER_ALARM_SLOW_MON_PWB_I:        
//        case ALARM_NUMBER_ALARM_FAST_MON_PWB_I:            
//            error_die_forever();
//            break;     
//        
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS1:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMPOS1].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMPOS2:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMPOS2].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG1:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMNEG1].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_DUL_ALARMNEG2:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_DUL_ALARMNEG2].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_HYDRO_PWR_FAULT:  return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_HYDRO_PWR_FAULT].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_LBL_PWR_FAULT:    return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_LBL_PWR_FAULT].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_FAULT:       return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRA_FAULT].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_FAULT:       return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRB_FAULT].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_FAULT: return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_POWERBOARD_FAULT].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_GLRA_GOOD:        return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRA_GOOD].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_GLRB_GOOD:        return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_GLRB_GOOD].alarm);
//        case ALARM_NUMBER_ALARM_FLAG_POWERBOARD_GOOD:  return &(digital_variables[DIGITAL_VARIABLE_INDEX_FLAG_POWERBOARD_GOOD].alarm);
//        
//    }
//    error_die_forever();
//    // never reached, just to avoid one warning
//    return &(digital_variables[0].alarm);
//}

bool* alarm_get_enable_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->enabled);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->enabled);        
    }    
}

alarm_timeout_t* alarm_get_timeout_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->timeout);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->timeout);        
    }        
}

//alarm_timeout_t* alarm_get_timeout_counter_ptr_by_enum(enum_alarm_number_t _alarm_index) {
//    if(alarm_is_analog_by_enum(_alarm_index)) {
//        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->timeout_counter);
//    }else{
//        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->timeout_counter);        
//    }        
//}

alarm_timeout_t* alarm_get_timeout_counter_max_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->timeout_counter_max);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->timeout_counter_max);        
    }        
}

alarm_firecount_t* alarm_get_firecount_ptr_by_enum(enum_alarm_number_t _alarm_index) {
    if(alarm_is_analog_by_enum(_alarm_index)) {
        return &(alarm_get_analog_alarm_ptr_by_enum(_alarm_index)->firecount);
    }else{
        return &(alarm_get_digital_alarm_ptr_by_enum(_alarm_index)->firecount);        
    }        
}

//DA RIVEDERE...
//// open switch SWITCH_VEOC_RETURN and update switch structure (call from irq only)
//void switch_SWITCH_VEOC_RETURN_set_open_irq(void) {
//    DIGITAL_OUT_SWITCH_VEOC_RETURN_SetLow();
//    switches.state_SWITCH_VEOC_RETURN = SWITCHSTATE_OPEN;
//}
//
//// open switch SWITCH_VEOC_DIRECT and update switch structure (call from irq only)
//void switch_SWITCH_VEOC_DIRECT_set_open_irq(void) {
//    DIGITAL_OUT_SWITCH_VEOC_DIRECT_SetLow();
//    switches.state_SWITCH_VEOC_DIRECT = SWITCHSTATE_OPEN;
//}
//
//// open switch SWITCH_12V_ENABLE and update switch structure (call from irq only)
//void switch_SWITCH_12V_ENABLE_set_open_irq(void) {
//    DIGITAL_OUT_SWITCH_12V_ENABLE_SetLow();
//    switches.state_SWITCH_12V_ENABLE = SWITCHSTATE_OPEN;
//}
//
//// open switch SWITCH_HYDRO and update switch structure (call from irq only)
//void switch_SWITCH_HYDRO_set_open_irq(void) {
//    DIGITAL_OUT_SWITCH_HYDRO_SetLow();
//    switches.state_SWITCH_HYDRO = SWITCHSTATE_OPEN;
//}
//
//// open switch SWITCH_LBL and update switch structure (call from irq only)
//void switch_SWITCH_LBL_set_open_irq(void) {
//    DIGITAL_OUT_SWITCH_LBL_SetLow();
//    switches.state_SWITCH_LBL = SWITCHSTATE_OPEN;
//}

void dummy_alarm_callback(void) {
    // should never be called
    error_die_forever();
}
